#!/usr/bin/env python3

# File: stereo_intrins_extrins_gen.py
# Company: ModalAi, Inc. 
# Author: Rich Martin (rich@modalai.com)
# Description: Generates an OpenCV stereo camera instrinsics and extrinsics calibration yml files from  
# YAML files generated by the ROS calibration tool.

#RGM NOTE:
#pip3 install the following: 
#pip3 install ruamel.yaml
#pip3 install opencv-python

import sys
import argparse
import os.path
import numpy as np
import ruamel.yaml as yaml 
import cv2

ros_left_default           = "/tmp/calibrationdata/left.yaml"
ros_right_default          = "/tmp/calibrationdata/right.yaml"
opencv_intrinsics_default  = "opencv_stereo_intrinsics.yml"
opencv_extrinsics_default  = "opencv_stereo_extrinsics.yml"
show_files = True

parser = argparse.ArgumentParser(description='Generate OpenCV Stereo Calibration Files')
parser.add_argument('-l','--left', dest='ros_left_file', action='store',
                     default=ros_left_default,   
                     help = f"ROS Left stereo calibration YAML file. Default is {ros_left_default}") 

parser.add_argument('-r','--right', dest='ros_right_file', action='store',
                     default=ros_right_default,   
                     help = f"ROS Right stereo calibration YAML file. Default is {ros_right_default}") 

parser.add_argument('-i', '--intrinsics', dest='opencv_intrins_file', action='store',
                     default=opencv_intrinsics_default,
                     help  = f"OpenCV intrinsics stereo calibration output file. \
                               Default is {opencv_intrinsics_default}")

parser.add_argument('-e', '--extrinsics', dest='opencv_extrins_file', action='store',
                     default=opencv_extrinsics_default,
                     help  = f"OpenCV extrinsics stereo calibration output file. \
                               Default is {opencv_extrinsics_default}")


args = parser.parse_args()

#check if files exist before continuing
ros_left          = args.ros_left_file
ros_right         = args.ros_right_file
opencv_intrinsics = args.opencv_intrins_file
opencv_extrinsics = args.opencv_extrins_file

print(f"Generating {opencv_intrinsics} and {opencv_extrinsics} . . .")

if not os.path.isfile(ros_left):
  sys.exit(ros_left + " file not found.")
elif not os.path.isfile(ros_right):
  sys.exit(ros_right + " file not found.")

cv_intrins = cv2.FileStorage(opencv_intrinsics, cv2.FILE_STORAGE_WRITE)
cv_extrins = cv2.FileStorage(opencv_extrinsics, cv2.FILE_STORAGE_WRITE)

#Read YAML calibration files
with open(ros_left, 'r') as ymlfile:
  try:
    ros_left_calib = yaml.safe_load(ymlfile) 
  except yaml.YAMLError as exc:
    sys.exit(exc)

with open(ros_right, 'r') as ymlfile:
  try:
    ros_right_calib = yaml.safe_load(ymlfile) 
  except yaml.YAMLError as exc:
    sys.exit(exc)


#left camera
img_w_l = ros_left_calib['image_width']
img_h_l = ros_left_calib['image_height'] 
K_l = np.array(ros_left_calib['camera_matrix']['data'])
D_l = np.array(ros_left_calib['distortion_coefficients']['data'])
dist_model_l = ros_left_calib['distortion_model']
P_l = np.array(ros_left_calib['projection_matrix']['data'])
R_l = np.array(ros_left_calib['rectification_matrix']['data'])

#right camera
img_w_r = ros_right_calib['image_width']
img_h_r = ros_right_calib['image_height'] 
K_r = np.array(ros_right_calib['camera_matrix']['data'])
D_r = np.array(ros_right_calib['distortion_coefficients']['data'])
dist_model_r = ros_right_calib['distortion_model']
P_r = np.array(ros_right_calib['projection_matrix']['data'])
R_r = np.array(ros_right_calib['rectification_matrix']['data'])

#parameter substitutions and calcuations originate from the following repository (lines 107 - 177):
#https://github.com/ATLFlight/dfs-ros-example/blob/master/src/nodes/SnapdragonDfsRos.cpp


#translation calculation
R_r  = R_r.reshape(3,3);
K_prime = np.array([[P_r[0], P_r[1], P_r[2]],
		                [P_r[4], P_r[5], P_r[6]],
                    [P_r[8], P_r[9], P_r[10]]]);
T_prime = np.array([P_r[3], P_r[7], P_r[11]]);
T = np.dot(np.linalg.inv(K_prime),T_prime);
translation = np.dot(R_r.transpose(),T);  

#rotation calculation
rotation = np.array([0, 0, 0]);
rotation_scaled_axis_angle = np.array([0, 0, 0]);
R_l  = R_l.reshape(3,3);
rotation_axis_angle = np.dot(R_r.transpose(), R_l)


#write intrinsics OpenCV files
cv_intrins.write('M1', np.reshape(K_l, (3, 3)))
cv_intrins.write('D1', np.array(D_l))
cv_intrins.write('M2', np.reshape(K_r, (3, 3)))
cv_intrins.write('D2', np.array(D_r))
cv_intrins.write('distortion_model', dist_model_l)
cv_intrins.write('width', img_w_l)
cv_intrins.write('height', img_h_l)
cv_intrins.release()


cv_extrins.write('R', rotation_axis_angle)
cv_extrins.write('T', translation )
cv_extrins.release()

if show_files:
  print("\nStereo Intrinics:\n")
  os.system(f"cat  {opencv_intrinsics}")
  print("\nStereo Extrinsics:\n")
  os.system(f"cat  {opencv_extrinsics}")